#ifndef SOLVERHAD_H
#define SOLVERHAD_H

#include <vector>

#include "SolverPRT.h"
#include "puzzle.h"
#include "miniPuzzle.h"

using std::vector;

class SolverHad: public SolverPRT
{
public:

	SolverHad();
	~SolverHad();

	std::string Solve();
	void SetPuzzle(const Puzzle& _puzzle);
	void SetMaskValue(int position, int value);
	void SetMaskValue(int x, int y, int value);
	int GetMaskValue(int position) const;



	int CountSteps1(int poziceStart, int poziceCil, int poziceKamen, const char smer, bool prvniRadek, bool prvniSloupec);
	int CountSteps2(int poziceStart, int poziceCil, int poziceKamen1, int poziceKamen2, bool hlava1);
	void FindTargetCoord(int startRow, int startCol, int& cilRow, int& cilCol, const char smer, int& targetRow, int& targetCol);

	void Test();										// jen testovaci fce



	// int vyplati;
	// int nevyplati;


protected:
		
	void SolveFirstRow1();
	void SolveFirstRow2();
	void SolveFirstCol1();
	void SolveFirstCol2();

	void SolveTileRow(int tileRow, int TileCol, int goalRow, int goalCol);
	void SolveTileCol(int tileRow, int TileCol, int goalRow, int goalCol);
	bool SolveSnake(int tile1Row, int tile1Col, int tile2Row, int tile2Col);
	void FindMeetingPoint(int tile1Row, int tile1Col, int tile2Row, int tile2Col, int& targetRow, int& targetCol);
	void PlanPathRow();
	void PlanPathCol();
	bool ExecutePath();
	bool InitSnake(int tile1, int tile2);
	string FindMovesTo(int position);

	void MoveZeroToCoord(int row, int col);
	void MoveTileToCoords(int tileRow, int tileCol, int targetRow, int targetCol, char poziceMezery);
	void MoveAlongSnake();

	void MaSouseda(int tileNumber,int tilePosition);

	bool TrimBoard();

	
	int tilePosition;
	int nextTilePosition;
	int goalPosition;
	int zeroPosition;

	vector<int> plan;				// plan cesty hada
	vector<int> snake;				// aktualni had (pozice, ktere zabira)

	int mask[PUZZLE_MAX_N][PUZZLE_MAX_N];





};


// ********************************************************************
// ****                    konstantni makra:                       ****
// ********************************************************************


const int KROKU_1_ROVNE				=		5;			// kolik kroku je potreba pro posun 1 kamene o 1 pole rovne
const int KROKU_1_SIKMO				=		6;			// kolik kroku je potreba pro posun 1 kamene o 1 pole sikmo
const int KROKU_2_ROVNE				=		7;			// kolik kroku je potreba pro posun 2 kamenu o 1 pole rovne
const int KROKU_2_SIKMO				=		10;			// kolik kroku je potreba pro posun 2 kamenu o 1 pole sikmo

const double HAD_KOEF = 1.2;
const int IMPR_KOEF = 2;

#endif