#ifndef MINI_PUZZLE_H
#define MINI_PUZZLE_H

#define MINIBOARD_N 3
#define MINIBOARD_SIZE 9

#include <iostream>
#include <string>
#include <queue>
#include <deque>
#include <vector>
#include <functional>
using namespace std;


class GraphNode
{
public:
	GraphNode();
	GraphNode(int _g, string _path);
	// GraphNode(const GraphNode* _node,const char move);
	~GraphNode();

	bool CanUseMove(const char move) const;
	bool DoMove(const char move);

	unsigned heur() const;
	int f() const;
	
	int tiles[MINIBOARD_SIZE];

	string path;
	unsigned zero;			// pozice 0
	unsigned g;				// ujeta vzdalenost
	int h;					// heuristika, pri inicializaci -1
	// bool valid;				// jestli neni vrchol nadbytecny (TRUE=ok, FALSE=zbytecny)
};


class mycomparison
{
public:
  mycomparison()
    {}
  bool operator() (const GraphNode* n1, const GraphNode* n2) const
  {
	  bool je_lepsi = n1->f() > n2->f();
	  return je_lepsi;
  }
};

typedef priority_queue<GraphNode*,deque<GraphNode*>, mycomparison > NODEQUEUE;


GraphNode * newGraphNode(const GraphNode* _node, const char move);

// *** A* algoritmus ***
std::string miniPuzzleSearch(const vector<int>& board);


#endif